  /*
  Для WeMos, связанной с Исполнительным Устройством.
  Приём от Ардуино режима работы. 
  Выдача сигналов на излучатель.
  Обработка входного сигнала полностью и передача результатов на Ардуино.
  */

  #include <ledc.h>                       // Подключение библиотеки ШИМ
  #include <esp_now.h>
  #include <Arduino.h>                    // библиотека Arduino 
  #include <WiFi.h>
  #include <esp_wifi.h>

                    // Новый MAC Address этой платы
  uint8_t newMACAddress[] = {0x30, 0x83, 0x98, 0xB2, 0x6E, 0xAF};    
 
 	 // МАС-АДРЕС платы, на которую отправляем данные. C8:C9:A3:6A:D9:64
  uint8_t broadcastAddress[] = {0xC8, 0xC9, 0xA3, 0x6A, 0xD9, 0x64};

  #define  STR_Pin          16            // назначение вывода STR
  #define  FO_Pin           18            // назначение вывода FO
  #define  DC_Pin           33            // назначение вывода DC
  #define  echoPinA         1             // назначение вывода echoA L4 (3500 mV)
  #define  echoPinB         2             // назначение вывода echoB L3 (2500 mV)
  #define  echoPinC         4             // назначение вывода echoC L2 (1000 mV)
  #define  echoPinD         6             // назначение вывода echoD L1 (200 mV)

  #define  A0R_Pin         39             // назначение вывода A0R
  #define  A1R_Pin         37             // назначение вывода A1R

  #define  analog1Pin       8             // назначение вывода analog1Pin Uпит излучателя

  #define  MOSI_PIN        11             // назначение вывода MOSI_PIN
  #define  MISO_PIN         9             // назначение вывода MISO_PIN
  #define  SCK_PIN          7             // назначение вывода SCK_PIN
  #define  SS_PIN          12             // назначение вывода SS_PIN
  #define  CSB_PIN          5             // назначение вывода CSB_PIN

  #define  PUSK_Pin        35             // назначение вывода PUSK
  #define  START_Pin        3             // назначение вывода START


			  // Вводим переменные для строба ШИМ
  volatile int pwmfrequency = 20000;      // 20 кГц - 4; 10 кГц - 8; 5 кГц - 16 импульсов.
  volatile int target_duty = 256;         // Целевая скважность, до неё доходит.
  uint32_t scale = 1;                     // Количество импульсов, на которое изменяется скважность.
  uint32_t cycle_num = 1;                 // Количество периодов, через которое будет достигнута целевая скважность.
  uint32_t dutyCycle = 255;               // Начальная скважность.
  uint32_t idle_level = 0;                // Уровень выходного сигнала при выключении фадинга.
  uint32_t freqCLK = 20000;               // Частота ШИМ

			 // Вводим переменные для частоты ШИМ
  const int ledPin0 = FO_Pin;             // GPIO18	FO_Pin
  const int ledChannel0 = 0;              // Канал 0
  const int resolution0 = 2;              // Разрешение 2 бит
  const int dutyCycle0 = 2;               // Скважность 2 
  const int dutyCycle1 = 0;               // Скважность 0
  const uint32_t freq0 = 80000;           // Частота выходного сигнала

  float analog1 = 0.0;                    // объявление переменной analog1
  uint32_t start;                         // Время старта
  uint32_t now;                           // Текущее машинное время в мкс
  uint16_t durationA;                     // объявление переменной длительности сигнала от приёмника
  uint16_t durationB;                     // объявление переменной длительности сигнала от приёмника
  uint16_t durationC;                     // объявление переменной длительности сигнала от приёмника
  uint16_t durationD;                     // объявление переменной длительности сигнала от приёмника
  uint32_t prevUsA;                       // Предыдущее время изменения состояния пина
  uint32_t prevUsB;                       // Предыдущее время изменения состояния пина
  uint32_t prevUsC;                       // Предыдущее время изменения состояния пина
  uint32_t prevUsD;                       // Предыдущее время изменения состояния пина

  int p = 0;                              // количество импульсов
  int u = 0;                              // усиление
  int countA = 0;                         // Счётчик циклов канала A
  int countB = 0;                         // Счётчик циклов канала B
  int countC = 0;                         // Счётчик циклов канала C
  int countD = 0;                         // Счётчик циклов канала D
  bool prevSA,flagA = 0;                  // флаг не первого измерения, флаг ошибки канала A
  bool prevSB,flagB = 0;                  // флаг не первого измерения, флаг ошибки канала B
  bool prevSC,flagC = 0;                  // флаг не первого измерения, флаг ошибки канала C
  bool prevSD,flagD = 0;                  // флаг не первого измерения, флаг ошибки канала D
  bool flagrec = 0;                       // флаг приёма данных

  #define LOG_SIZE 10                     // размер лога (LOG_SIZE ячеек)
  #define CHN_SIZE 4                      // размер лога (CHN_SIZE массивов каналов)
  uint8_t regout = 0x3A;                  // регистр выдачи на исполнительное устройство
  uint16_t dursig;                        // длительность сигнала от приёмника
  uint16_t us[CHN_SIZE][LOG_SIZE+5];      // массив измерений. Для длительности отрезков между изменениями входа

			 // Вводим переменные для хранения отправляемых данных
  float voltage1 = 0.0;                   // объявление переменной voltage1 
  uint16_t durus[CHN_SIZE][LOG_SIZE+5];   // массив измерений. Для текущего времени в момент изменения

          // Вводим переменные для хранения принимаемых данных
  uint8_t  incomingReg1;
 
         // Переменная для хранения состояния отправки
  String success;
 
                  // структура для приёма данных
        // (Должна совпадать со структурой передачи на плате-приемнике)
  typedef struct struct_recmes {
  uint8_t reg1;
  } struct_recmes;

                 // структура для отправки данных
         // (Должна совпадать со структурой приёма на плате-приемнике)
  typedef struct struct_sendmes {
  float voltbat;                          // напряжение батареи
  uint16_t arrey1[CHN_SIZE][LOG_SIZE+5];  // массив измерений. 
  } struct_sendmes;
 
         // Создаем переменную для хранения отправляемого сообщения
  struct_sendmes ISPReadings;
 
               // То же, но для принимаемого сообщения
  struct_recmes incomingReadings;

        // Callback-функция для получения состояния отправки
  esp_now_peer_info_t peerInfo;

  void OnDataSent(const uint8_t *mac_addr, esp_now_send_status_t status) {
  //Serial.print("\r\nLast Packet Send Status:\t");
  //Serial.println(status == ESP_NOW_SEND_SUCCESS ? "Delivery Success" : "Delivery Fail");
  if (status ==0){
    success = "Delivery Success :)";
  } else {
    success = "Delivery Fail :(";
  }
  }
            // То же, для индикации состояния приема данных
  void OnDataRecv(const uint8_t * mac, const uint8_t *incomingData, int len) {
  memcpy(&incomingReadings, incomingData, sizeof(incomingReadings));
  //Serial.print("Bytes received: ");
  //Serial.println(len);

                          // приём данных
  regout = incomingReadings.reg1;
  // printIncomingReadings();
  initial();
  flagrec = 1;                          // устанавливаем в 1 флаг приёма данных 
  }

  /*
  void printIncomingReadings(){
          // Отображаем показания в мониторе порта
  Serial.println("INCOMING READINGS"); 
  Serial.print("regout: ");
  Serial.println(regout, BIN);
  Serial.println(" ");
  }

  void printSendingData(){
  Serial.println("SENDING_DATA");
  Serial.print("voltage1: ");
  Serial.println(voltage1);
  for (int l = 0; l < CHN_SIZE; l++) {           // перебираем каналы
  Serial.print("Канал"); 
  Serial.println(l);
  Serial.println("durus: ");
  for (int i = 0; i < LOG_SIZE; i++) {           // перебираем импульсы
  Serial.println(durus[l][i]); 
  }
  Serial.print("duration"); 
  Serial.println( durus[l][LOG_SIZE]);
  
  Serial.print("count"); 
  Serial.println( durus[l][LOG_SIZE+1]);

  Serial.print("Канал"); 
  Serial.println( durus[l][LOG_SIZE+2]);

  Serial.print("Усиление"); 
  Serial.println( durus[l][LOG_SIZE+3]);

  Serial.print("Импульсов"); 
  Serial.println( durus[l][LOG_SIZE+4]);
  Serial.println(" ");
  } 
  Serial.println("Массив прочитан");
  Serial.println(" ");
  } 
  */

  void setup() {

  pinMode(STR_Pin, OUTPUT);             // назначение вывода STR_Pin выходом 
  pinMode(FO_Pin, OUTPUT);              // назначение вывода FO_Pin выходом 
  pinMode(DC_Pin, OUTPUT);              // назначение вывода DC_Pin выходом 
  pinMode(A0R_Pin, OUTPUT);             // назначение вывода A0R_Pin выходом 
  pinMode(A1R_Pin, OUTPUT);             // назначение вывода A1R_Pin выходом 

  pinMode(echoPinA, INPUT);             // назначение вывода echoA входом
  pinMode(echoPinB, INPUT);             // назначение вывода echoB входом
  pinMode(echoPinC, INPUT);             // назначение вывода echoC входом
  pinMode(echoPinD, INPUT);             // назначение вывода echoD входом 
  pinMode(analog1Pin, INPUT);           // назначение вывода analog1Pin входом 

  pinMode(MOSI_PIN, OUTPUT);            // назначение вывода MOSI_PIN выходом
  pinMode(MISO_PIN, INPUT);             // назначение вывода MISO_PIN входом
  pinMode(SCK_PIN, OUTPUT);             // назначение вывода SCK_PIN выходом 
  pinMode(SS_PIN, OUTPUT);              // назначение вывода SS_PIN выходом 
  pinMode(CSB_PIN, OUTPUT);             // назначение вывода CSB_PIN выходом 

  pinMode(PUSK_Pin, INPUT_PULLUP);      // назначение вывода PUSK_Pin входом
  pinMode(START_Pin, INPUT);            // назначение вывода START_Pin входом

                        // Конфигурация ШИМ
  ledc_timer_config_t ledc_timer;  
  ledc_timer.speed_mode   = LEDC_LOW_SPEED_MODE;
  ledc_timer.timer_num    = LEDC_TIMER_1;
  ledc_timer.duty_resolution = LEDC_TIMER_8_BIT;
  ledc_timer.freq_hz      = pwmfrequency;
  ledc_channel_config_t ledc_channel2;
  ledc_channel2.channel    = LEDC_CHANNEL_2;
  ledc_channel2.gpio_num   = STR_Pin;	// GPIO16 STR_Pin
  ledc_channel2.speed_mode = LEDC_LOW_SPEED_MODE;
  ledc_channel2.timer_sel  = LEDC_TIMER_1;
  ledc_channel2.duty       = dutyCycle;
  ledc_timer_config(&ledc_timer);
  ledc_channel_config(&ledc_channel2);
  ledc_fade_func_install(ESP_INTR_FLAG_SHARED);

       // конфигурируем функционирование LEDC PWM   
  ledcSetup(ledChannel0, freq0, resolution0);     // Задаём номер канала, частоту, скважность

       // attach the channel to the GPIO to be controlled
  ledcAttachPin(ledPin0, ledChannel0);            // Привязываем номер вывода к номеру канала

                        // Запускаем монитор порта
  // Serial.begin(115200);
  // Serial.println();
  
                        // Выставляем режим работы Wi-Fi
  WiFi.mode(WIFI_STA);
  WiFi.disconnect();
  WiFi.setTxPower(WIFI_POWER_MINUS_1dBm);         // Установка минимального уровня мощности WiFi

            // Устанавливаем новый MAC Address этой платы 
  esp_wifi_set_mac(WIFI_IF_STA, &newMACAddress[0]);

                // Инициализируем протокол ESP-NOW
  if (esp_now_init() != ESP_OK) {
  //Serial.println("Error initializing ESP-NOW");
  return;
  }
         // Регистрируем callback-функцию для получения статуса отправки
  esp_now_register_send_cb(OnDataSent);
 
              // Регистрируем пиры
  memcpy(peerInfo.peer_addr, broadcastAddress, 6);
  peerInfo.channel = 0;  
  peerInfo.encrypt = false;

                // Добавляем пиры
  if (esp_now_add_peer(&peerInfo) != ESP_OK){
  //Serial.println("Failed to add peer");
  return;
  }
        // Регистрируем callback-функцию для получения статуса приема
  esp_now_register_recv_cb(OnDataRecv);
  }
 
  void loop() {

  if (flagrec == 1) {                            // если пришла посылка от WeMosArd
  
                     // Чтение данных от приёмника
                     // читаем время и текущий пин 

  now = micros();                                // Читаем текущее машинное время

                  // Обрабатываем первый импульс канала D
  if (countD < LOG_SIZE) {                       // Если буфер не переполнен
  bool sD = digitalRead(echoPinD);               // Читаем текущее состояние пина
  if (prevSD != sD) {                            // Состояние пина изменилось?
  prevSD = sD;                                   // Если изменилось, запомнили текущее состояние
  if (!flagD) {                                  // Опрос флага (первое срабатывание?)
  flagD = 1;                                     // Если первое срабатывание, устанавливаем флаг в 1
  us[0][countD] = now - start;                   // время до первого импульса
  durus[0][countD] = us[0][countD];              // заносим время до первого импульса в durus[count]
  durationD = durus[0][countD];                  // duration = время до фронта первого импульса
  prevUsD = now;                                 // заносим текущее машинное время в prevUs
  countD++;                                      // + 1 в счётчик циклов
  } else {                                       // Если не первое срабатывание

                  // Обрабатываем следующие импульсы канала D
  us[0][countD] = now - prevUsD;                 // длительность импульса
  durus[0][countD] = (durus[0][countD - 1] + us[0][countD]);  // durus[0][count] = текущее время всех импульсов
  durationD = durus[0][countD - 1];              // duration = время до фронта последнего импульса
  durus[0][LOG_SIZE] = durationD;                // записываем duration
  durus[0][LOG_SIZE+1] = countD;                 // записываем count
  prevUsD = now;                                 // Запомнили машинное время
  countD++;                                      // + 1 в счётчик циклов 
  }}                                             // Если состояние пина не изменилось, идём дальше
  }                                              // Если буфер переполнен, ждём до окончания цикла 60 мс  
 
                  // Обрабатываем первый импульс канала C
  if (countC < LOG_SIZE) {                       // Если буфер не переполнен
  bool sC = digitalRead(echoPinC);               // Читаем текущее состояние пина
  if (prevSC != sC) {                            // Состояние пина изменилось?
  prevSC = sC;                                   // Если изменилось, запомнили текущее состояние
  if (!flagC) {                                  // Опрос флага (первое срабатывание?)
  flagC = 1;                                     // Если первое срабатывание, устанавливаем флаг в 1
  us[1][countC] = now - start;                   // время до первого импульса
  durus[1][countC] = us[1][countC];              // заносим время до первого импульса в durus[count]
  durationC = durus[1][countC];                  // duration = время до фронта первого импульса
  prevUsC = now;                                 // заносим текущее машинное время в prevUs
  countC++;                                      // + 1 в счётчик циклов
  } else {                                       // Если не первое срабатывание

                  // Обрабатываем следующие импульсы канала C
  us[1][countC] = now - prevUsC;                 // длительность импульса
  durus[1][countC] = (durus[1][countC - 1] + us[1][countC]);  // durus[1][count] = текущее время всех импульсов
  durationC = durus[1][countC - 1];              // duration = время до фронта последнего импульса
  durus[1][LOG_SIZE] = durationC;                // записываем duration
  durus[1][LOG_SIZE+1] = countC;                 // записываем count
  prevUsC = now;                                 // Запомнили машинное время
  countC++;                                      // + 1 в счётчик циклов 
  }}                                             // Если состояние пина не изменилось, идём дальше
  }                                              // Если буфер переполнен, ждём до окончания цикла 60 мс  

                  // Обрабатываем первый импульс канала B
  if (countB < LOG_SIZE) {                       // Если буфер не переполнен
  bool sB = digitalRead(echoPinB);               // Читаем текущее состояние пина
  if (prevSB != sB) {                            // Состояние пина изменилось?
  prevSB = sB;                                   // Если изменилось, запомнили текущее состояние
  if (!flagB) {                                  // Опрос флага (первое срабатывание?)
  flagB = 1;                                     // Если первое срабатывание, устанавливаем флаг в 1
  us[2][countB] = now - start;                   // время до первого импульса
  durus[2][countB] = us[2][countB];              // заносим время до первого импульса в durus[count]
  durationB = durus[2][countB];                  // duration = время до фронта первого импульса
  prevUsB = now;                                 // заносим текущее машинное время в prevUs
  countB++;                                      // + 1 в счётчик циклов
  } else {                                       // Если не первое срабатывание

                   // Обрабатываем следующие импульсы канала B
  us[2][countB] = now - prevUsB;                 // длительность импульса
  durus[2][countB] = (durus[2][countB - 1] + us[2][countB]);   // durus[2][count] = текущее время всех импульсов
  durationB = durus[2][countB - 1];              // duration = время до фронта последнего импульса
  durus[2][LOG_SIZE] = durationB;                // записываем duration
  durus[2][LOG_SIZE+1] = countB;                 // записываем count
  prevUsB = now;                                 // Запомнили машинное время
  countB++;                                      // + 1 в счётчик циклов 
  }}                                             // Если состояние пина не изменилось, идём дальше
  }                                              // Если буфер переполнен, ждём до окончания цикла 60 мс  

                  // Обрабатываем первый импульс канала A
  if (countA < LOG_SIZE) {                       // Если буфер не переполнен
  bool sA = digitalRead(echoPinA);               // Читаем текущее состояние пина
  if (prevSA != sA) {                            // Состояние пина изменилось?
  prevSA = sA;                                   // Если изменилось, запомнили текущее состояние
  if (!flagA) {                                  // Опрос флага (первое срабатывание?)
  flagA = 1;                                     // Если первое срабатывание, устанавливаем флаг в 1
  us[3][countA] = now - start;                   // время до первого импульса
  durus[3][countA] = us[3][countA];              // заносим время до первого импульса в durus[count]
  durationA = durus[3][countA];                  // duration = время до фронта первого импульса
  prevUsA = now;                                 // заносим текущее машинное время в prevUs
  countA++;                                      // + 1 в счётчик циклов
  } else {                                       // Если не первое срабатывание

                    // Обрабатываем следующие импульсы канала A
  us[3][countA] = now - prevUsA;                 // длительность импульса
  durus[3][countA] = (durus[3][countA - 1] + us[3][countA]);  // durus[3][count] = текущее время всех импульсов
  durationA = durus[3][countA - 1];              // duration = время до фронта последнего импульса
  durus[3][LOG_SIZE] = durationA;                // записываем duration
  durus[3][LOG_SIZE+1] = countA;                 // записываем count
  prevUsA = now;                                 // Запомнили машинное время
  countA++;                                      // + 1 в счётчик циклов 
  }}                                             // Если состояние пина не изменилось, идём дальше
  }                                              // Если буфер переполнен, ждём до окончания цикла 60 мс  
  if (now - start > 60000) {                     // Если время измерения истекло
  for (int l = 0; l < CHN_SIZE; l++) {           // перебираем каналы
  durus[l][LOG_SIZE+2] = l;                      // записываем канал D
  durus[l][LOG_SIZE+3] = u;                      // записываем канал C
  durus[l][LOG_SIZE+4] = p;                      // записываем канал B
  }
  ledcWrite(ledChannel0, dutyCycle1);            // Останавливаем канал (0 на выходе)
  logOut();                                      // Переходим на вывод лога
  }                                              // Если время измерения не истекло
  }                                              // если не пришла посылка от WeMosArd
  }                                              // завершение void loop()
 
                          // Посылка строба ШИМ
  void setimp() {
  ledc_set_fade_with_step(LEDC_LOW_SPEED_MODE, LEDC_CHANNEL_2, target_duty, scale, cycle_num );
  ledc_set_duty(LEDC_LOW_SPEED_MODE, LEDC_CHANNEL_2, dutyCycle); 
  ledc_update_duty(LEDC_LOW_SPEED_MODE, LEDC_CHANNEL_2);
  ledc_fade_start(LEDC_LOW_SPEED_MODE, LEDC_CHANNEL_2, LEDC_FADE_WAIT_DONE);
  ledc_stop(LEDC_LOW_SPEED_MODE, LEDC_CHANNEL_2, idle_level);
  }

  void initial() {                               // Установка начальных значений 

  if (bitRead(regout,5) == 0) {                  // Если A0, то 
  p = 1;                                         // 8 импульсов
  } else                                         // Если 1, идём мимо
  if (bitRead(regout,3) == 0 ) {                 // Если 0, то 
  p = 2;                                         // 16 импульсов
  } else {                                       // Если 1, идём мимо
  p = 0;                                         // 4 импульса
  }
  if (bitRead(regout,2) == 0) {                  // Если A0, то 
  u = 0;                                         // усиление х1
  } else                                         // Если 1, идём мимо
  if (bitRead(regout,1) == 0 ) {                 // Если 0, то 
  u = 1;                                         // усиление х6
  } else {                                       // Если 1, идём мимо
  u = 2;                                         // усиление х36
  }
  for (int l = 0; l < CHN_SIZE; l++) {           // перебираем каналы
  for (int i = 0; i < LOG_SIZE+5; i++) {         // перебираем массив
  durus[l][i] = 0; } }                           // обнуляем массив
  durationA = 0;                                 // duration = время до фронта последнего импульса = 0
  durationB = 0;                                 // duration = время до фронта последнего импульса = 0
  durationC = 0;                                 // duration = время до фронта последнего импульса = 0
  durationD = 0;                                 // duration = время до фронта последнего импульса = 0
  flagA = 0;                                     // обнуляем флаг канала A
  flagB = 0;                                     // обнуляем флаг канала B
  flagC = 0;                                     // обнуляем флаг канала C
  flagD = 0;                                     // обнуляем флаг канала D
  countA = 0;                                    // Счётчик циклов канала A = 0
  countB = 0;                                    // Счётчик циклов канала B = 0
  countC = 0;                                    // Счётчик циклов канала C = 0
  countD = 0;                                    // Счётчик циклов канала D = 0
  prevSA = digitalRead(echoPinA);                // Запомнили начальное состояние текущего пина канала A
  prevSB = digitalRead(echoPinB);                // Запомнили начальное состояние текущего пина канала B
  prevSC = digitalRead(echoPinC);                // Запомнили начальное состояние текущего пина канала C
  prevSD = digitalRead(echoPinD);                // Запомнили начальное состояние текущего пина канала D
  send_CKL();                                    // Выводим сигнал запуска излучателя
  }

  void logOut() {    // передача полученных результатов на WeMosArd
                             // Читаем напряжение
  analog1 = analogRead(analog1Pin);              // читаем напряжение источника питания
  voltage1 = (analog1*20.9) / 4095;              // пересчитываем число в вольты 

  // printSendingData();      // печать отправляемых данных
                       // Записываем переменные для отправки
  ISPReadings.voltbat = voltage1;                // напряжение батареи
  for (int l = 0; l < CHN_SIZE; l++) {           // перебираем каналы
  for (int i = 0; i < LOG_SIZE+5; i++) {         // перебираем импульсы
  ISPReadings.arrey1[l][i] = durus[l][i];        // массив измерений
  } }
                                // Отправляем сообщение
  esp_now_send(broadcastAddress,(uint8_t*)&ISPReadings, sizeof(ISPReadings));
  flagrec = 0;                                   // сброс флага посылки 
  }

  void send_CKL() {           // выдача сигналов управления на исполнительное устройство
  			// Установка коэффициента усиления и DC
  digitalWrite(A0R_Pin, bitRead(regout, 2));     // запись состояния A0 в A0R_Pin
  digitalWrite(A1R_Pin, bitRead(regout, 1));     // запись состояния A1 в A1R_Pin
  digitalWrite(DC_Pin, !bitRead(regout, 4));     // запись состояния DC в DC_Pin

  			// Выдача частоты и строба
  if (bitRead(regout,5) == 0) {                  // Если A0, то коэф. = 1
  freqCLK = 10000;                               // Задаём частоту для 8 импульсов
  } else                                         // Если 1, идём мимо
  if (bitRead(regout,3) == 0 ) {                 // Если 0, то 16 импульсов
  freqCLK = 5000;                                // Задаём частоту для 16 импульсов
  } else {                                       // Если 1, идём мимо
  freqCLK = 20000;                               // Задаём частоту для 4 импульсов
  }
  ledcWrite(ledChannel0, dutyCycle0);            // Запускаем частоту 80 кГц
  ledc_set_freq(LEDC_LOW_SPEED_MODE, LEDC_TIMER_1, freqCLK); // Устанавливаем частоту
  setimp();                                      // Запускаем строб
  start = micros();
  }

  /*            7       6       5       4       3       2       1       0        

     regm1     X36      X6      X1   12/24V     -    16 имп   8 имп   4 имп                          
    
     reg_IN     -       -       -       D       C       B       A       -      

     regkn2   ЭКРАН     -      АВТО     D       C       B       A     СРЕДА 

       -        -       -       -      L1       L2      L3     L4       -        

       -        -       -       -     КАН 4   КАН 3    КАН 2   КАН 1    -          

     regout     -       -      A0T     DC      A1T     A0R     A1R      -                           
        0x3A                    1       1       1       0       1       0 

                               A0T   DC_Pin    A1T   A0R_Pin  A1R_Pin   0 
    активный уровень            0       1       0       0       0       0

  */                                        



 
